-- hds header_start
--
-- VHDL Entity CERC_FE_FPGA.ADC_Config1.symbol
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 09:04:28 02/10/06
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end

LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;
USE ieee.numeric_std.all;
USE ieee.vital_primitives.all;
USE ieee.vital_timing.all;
USE ieee.std_logic_textio.all;

entity ADC_Config1 is
   port( 
      ADDR0         : in     std_logic;
      ADDR1         : in     std_logic;
      CLK           : in     std_logic;
      CONFIG_SELECT : in     std_logic;
      MCOUNT        : in     std_logic_vector (31 downto 0);
      MLD           : in     std_logic;
      RESET         : in     std_logic;
      SET_DATA      : in     std_logic_vector (31 downto 0);
      rd            : in     std_logic;
      wr            : in     std_logic;
      A0_SET        : out    std_logic;
      CONV_ENABLE   : out    std_logic;
      CONV_SET      : out    std_logic;
      LDOUT         : out    std_logic;
      M0_SET        : out    std_logic;
      M1_SET        : out    std_logic;
      conv_count    : out    std_logic_vector (31 downto 0);
      db_out        : out    std_logic_vector (31 downto 0)
   );

-- Declarations

end ADC_Config1 ;


-- hds interface_end

--
-- VHDL Architecture CERC_FE_FPGA.ADC_Config1.struct
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 09:04:28 02/10/06
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--

LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;
USE ieee.std_logic_unsigned.ALL;


architecture struct of ADC_Config1 is

   -- Architecture declarations

   -- Internal signal declarations
   signal A0_SET_int     : std_logic;
   signal CONV_SET_int   : std_logic;
   signal M0_SET_int     : std_logic;
   signal M1_SET_int     : std_logic;
   signal a_int          : std_logic;
   signal a_int1         : std_logic;
   signal conv_count_int : std_logic_vector(31 downto 0);
   signal endcount_int   : std_logic_vector(31 downto 0);
   signal startcount_int : std_logic_vector(31 downto 0);



begin
   -- Architecture concurrent statements
   -- HDL Embedded Text Block 2 DATA_LATCH
   -- ADC Cofiguration Data
   config:process (CLK)
   
   begin
   
    if (CLK'event and CLK='0') then
      if (RESET = '1') then
        a_int1 <='0';
       db_out <= (others => 'Z');
        startcount_int <= (others => '0');
        endcount_int <= (others => '0') ;
   
        A0_SET_int <= '1';
        M0_SET_int <= '0';
        M1_SET_int <= '0';
        CONV_SET_int <= '1';
        conv_count_int <= (others => '0') ;
     
      elsif(CONFIG_SELECT = '1' and ADDR0='0' and ADDR1='0' and wr='1') then
         startcount_int <= SET_DATA;
         a_int1<= '0';
   
      elsif(CONFIG_SELECT = '1' and ADDR0='1' and ADDR1 = '0' and wr='1') then
         endcount_int <= SET_DATA;
         a_int1<= '0';
   
      elsif(CONFIG_SELECT = '1' and ADDR0='0' and ADDR1 = '1' and wr='1') then
        A0_SET_int <= SET_DATA(0);
        M0_SET_int <= SET_DATA(1);
        M1_SET_int <= SET_DATA(2);
        CONV_SET_int <= SET_DATA(3);
   
      elsif(CONFIG_SELECT = '1' and ADDR0='1' and ADDR1 = '1' and wr='1') then
        conv_count_int <= SET_DATA(31 downto 0);
        a_int1<= '0';
   
      elsif(CONFIG_SELECT = '1' and ADDR0='0' and ADDR1='0' and rd='1') then
         db_out <= startcount_int;
   
      elsif(CONFIG_SELECT = '1' and ADDR0='1' and ADDR1 = '0' and rd='1') then
         db_out <= endcount_int ;
   
   
      elsif(CONFIG_SELECT = '1' and ADDR0='0' and ADDR1 = '1' and rd='1') then
        db_out(0) <= A0_SET_int;
        db_out(1) <= M0_SET_int ;
        db_out(2) <= M1_SET_int ;
        db_out(3) <= CONV_SET_int ;
        db_out(31 downto 4) <=(others=>'0');
   
      elsif(CONFIG_SELECT = '1' and ADDR0='1' and ADDR1 = '1' and rd='1') then
        db_out(31 downto 0) <= conv_count_int ;
   
      elsif(CONFIG_SELECT = '0' or rd = '0') then 
       db_out <= (others => 'Z');
   
      end if;
    end if;
   end process config;
   --
   DATA_LATCH:process (CLK)
   
   begin
   
    if (CLK'event and CLK='0') then
      if (RESET = '1') then
        CONV_ENABLE <= '0';
        LDOUT <='0';
        a_int<='0';
   
      elsif (MLD = '1') then 
   
        if(a_int1 = '0' and a_int='0') then
          LDOUT <='1';
          a_int<='1';
        else
          LDOUT <='0';
        end if;
       
        if (MCOUNT >= startcount_int and MCOUNT < endcount_int) then
           CONV_ENABLE <= '1';  
         else 
           CONV_ENABLE <= '0';
         end if;
   
      elsif(MLD='0') then
         CONV_ENABLE <= '0';
      end if;
   
   end if;
   
   end process DATA_LATCH;
   
        conv_count <= conv_count_int;
        A0_SET <= A0_SET_int ;
        M0_SET <= M0_SET_int ;
        M1_SET <= M1_SET_int ;
        CONV_SET <= CONV_SET_int ;

   -- Instance port mappings.

end struct;
