-- hds header_start
--
-- VHDL Entity CERC_FE_FPGA.adc_signals_1.symbol
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 09:04:27 02/10/06
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end

LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;
USE ieee.numeric_std.all;
USE ieee.std_logic_unsigned.ALL;

entity adc_signals_1 is
   port( 
      A0_SET     : in     std_logic;
      ADC_TRIG   : in     std_logic;
      CONVST_SET : in     std_logic;
      M0_SET     : in     std_logic;
      M1_SET     : in     std_logic;
      RESET      : in     std_logic;
      SCLK       : in     std_logic;
      A0         : out    std_logic;
      CONVST     : out    std_logic;
      CONV_END   : out    std_logic;
      CS_B       : out    std_logic;
      M0         : out    std_logic;
      M1         : out    std_logic;
      RD         : out    std_logic
   );

-- Declarations

end adc_signals_1 ;


-- hds interface_end

--
-- VHDL Architecture CERC_FE_FPGA.adc_signals_1.fsm
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 09:04:27 02/10/06
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;
USE ieee.std_logic_unsigned.ALL;

architecture fsm of adc_signals_1 is

   -- Architecture Declarations
   type state_type is (
      s3,
      s2,
      s1,
      s4,
      start,
      s20,
      s5,
      s19,
      s6,
      s17,
      s18,
      s7,
      s16,
      s15,
      s8,
      s14,
      s13,
      s9,
      s10,
      s12,
      s11
   );

   -- State vector declaration
   attribute state_vector : string;
   attribute state_vector of fsm : architecture is "current_state" ;


   -- Declare current and next state signals
   signal current_state : state_type ;
   signal next_state : state_type ;

begin

   ----------------------------------------------------------------------------
   clocked : process(
      SCLK,
      RESET
   )
   ----------------------------------------------------------------------------
   begin
      if (RESET = '1') then
         current_state <= start;
         -- Reset Values
      elsif (SCLK'event and SCLK = '1') then
         current_state <= next_state;
         -- Default Assignment To Internals

      end if;

   end process clocked;

   ----------------------------------------------------------------------------
   nextstate : process (
      ADC_TRIG,
      current_state
   )
   ----------------------------------------------------------------------------
   begin
      case current_state is
      when s3 =>
            next_state <= s4;
      when s2 =>
            next_state <= s3;
      when s1 =>
            next_state <= s2;
      when s4 =>
            next_state <= s5;
      when start =>
         if (ADC_TRIG = '1') then
            next_state <= s1;
         elsif (ADC_TRIG = '0') then
            next_state <= start;
         else
            next_state <= start;
         end if;
      when s20 =>
            next_state <= start;
      when s5 =>
            next_state <= s6;
      when s19 =>
            next_state <= s20;
      when s6 =>
            next_state <= s7;
      when s17 =>
            next_state <= s18;
      when s18 =>
            next_state <= s19;
      when s7 =>
            next_state <= s8;
      when s16 =>
            next_state <= s17;
      when s15 =>
            next_state <= s16;
      when s8 =>
            next_state <= s9;
      when s14 =>
            next_state <= s15;
      when s13 =>
            next_state <= s14;
      when s9 =>
            next_state <= s10;
      when s10 =>
            next_state <= s11;
      when s12 =>
            next_state <= s13;
      when s11 =>
            next_state <= s12;
      when others =>
         next_state <= start;
      end case;

   end process nextstate;

   ----------------------------------------------------------------------------
   output : process (
      A0_SET,
      CONVST_SET,
      M0_SET,
      M1_SET,
      current_state
   )
   ----------------------------------------------------------------------------
   begin
      -- Default Assignment
      A0 <= '0';
      CONVST <= '0';
      CONV_END <= '0';
      CS_B <= '1';
      M0 <= '0';
      M1 <= '0';
      RD <= '0';
      -- Default Assignment To Internals

      -- Combined Actions
      case current_state is
      when s3 =>
         convst <='0' ;
         CS_B <= '0' ;
         M0 <= M0_SET ;
         M1 <= M1_SET ;
         A0<='0';
         rd <= '0' ;
      when s2 =>
         convst <= CONVST_SET ;
         CS_B <= '0' ;
         M0 <= M0_SET ;
         M1 <= M1_SET ;
         A0<=A0_SET;
         rd <= '1' ;
      when s1 =>
         convst <= CONVST_SET ;
         CS_B <= '0' ;
         M0 <= M0_SET ;
         M1 <= M1_SET ;
         A0<=A0_SET;
         rd <= '1' ;
         CONV_END<='0';
      when s4 =>
         CS_B <= '0' ;
         M0 <= M0_SET ;
         M1 <= M1_SET ;
         rd <= '0' ;
      when start =>
         convst <= '0' ;
         CS_B <= '1' ;
         M0 <= M0_SET ;
         M1 <= M1_SET ;
         rd <= '0' ;
         A0<=A0_SET;
         CONV_END <='1';
      when s20 =>
         CS_B <= '0' ;
         M0 <= M0_SET ;
         M1 <= M1_SET ;
         rd <= '0' ;
         CONV_END <='0';
      when s5 =>
         CS_B <= '0' ;
         M0 <= M0_SET ;
         M1 <= M1_SET ;
         rd <= '0' ;
      when s19 =>
         CS_B <= '0' ;
         M0 <= M0_SET ;
         M1 <= M1_SET ;
         rd <= '0' ;
      when s6 =>
         CS_B <= '0' ;
         M0 <= M0_SET ;
         M1 <= M1_SET ;
         rd <= '0' ;
      when s17 =>
         CS_B <= '0' ;
         M0 <= M0_SET ;
         M1 <= M1_SET ;
         rd <= '0' ;
      when s18 =>
         CS_B <= '0' ;
         M0 <= M0_SET ;
         M1 <= M1_SET ;
         rd <= '0' ;
      when s7 =>
         CS_B <= '0' ;
         M0 <= M0_SET ;
         M1 <= M1_SET ;
         rd <= '0' ;
      when s16 =>
         CS_B <= '0' ;
         M0 <= M0_SET ;
         M1 <= M1_SET ;
         rd <= '0' ;
      when s15 =>
         CS_B <= '0' ;
         M0 <= M0_SET ;
         M1 <= M1_SET ;
         rd <= '0' ;
      when s8 =>
         CS_B <= '0' ;
         M0 <= M0_SET ;
         M1 <= M1_SET ;
         rd <= '0' ;
      when s14 =>
         convst <='0' ;
         CS_B <= '0' ;
         M0 <= M0_SET ;
         M1 <= M1_SET ;
         rd <= '0' ;
      when s13 =>
         CS_B <= '0' ;
         M0 <= M0_SET ;
         M1 <= M1_SET ;
         rd <= '0' ;
      when s9 =>
         CS_B <= '0' ;
         M0 <= M0_SET ;
         M1 <= M1_SET ;
         rd <= '0' ;
      when s10 =>
         CS_B <= '0' ;
         M0 <= M0_SET ;
         M1 <= M1_SET ;
         rd <= '0' ;
      when s12 =>
         CS_B <= '0' ;
         M0 <= M0_SET ;
         M1 <= M1_SET ;
         rd <= '0' ;
      when s11 =>
         CS_B <= '0' ;
         M0 <= M0_SET ;
         M1 <= M1_SET ;
         rd <= '0' ;
      when others =>
         null;
      end case;

   end process output;

   -- Concurrent Statements

end fsm;
