-- hds header_start
--
-- VHDL Entity CERC_FE_FPGA.comms.symbol
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 14:07:27 03/10/06
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end

LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;
USE ieee.numeric_std.all;
USE ieee.std_logic_textio.all;
USE ieee.std_logic_unsigned.ALL;

entity comms is
   port( 
      addr             : in     std_logic_vector (9 downto 0);
      clk40            : in     std_logic;
      clk40d           : in     std_logic;
      clk80            : in     STD_ULOGIC;
      db_in            : in     std_logic_vector (31 downto 0);
      db_rd            : in     std_logic;
      db_wr            : in     std_logic;
      fifo_data_count  : in     std_logic_VECTOR (9 downto 0);
      fifo_data_out    : in     std_logic_vector (31 downto 0);
      fifo_empty       : in     std_logic;
      fifo_full        : in     std_logic;
      fkev_busy        : in     std_logic;
      fkev_mode        : in     std_logic;
      readout_sync_in  : in     std_logic;
      rst              : in     std_logic;
      trigger          : in     std_logic;
      db_out           : out    std_logic_vector (31 downto 0);
      fifo_rd          : out    std_logic;
      frame_sync_out   : out    STD_ULOGIC;
      readout_sync_out : out    STD_ULOGIC;
      ser_data_out     : out    std_logic_vector (3 downto 0);
      syncin_detected  : out    std_logic
   );

-- Declarations

end comms ;


-- hds interface_end

--
-- VHDL Architecture CERC_FE_FPGA.comms.struct
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 14:07:47 03/10/06
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--

LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;
USE ieee.std_logic_unsigned.ALL;

library CERC_FE_FPGA;
library unisim;

architecture struct of comms is

   -- Architecture declarations

   -- Internal signal declarations
   signal clk80B_1         : std_logic;
   signal clk80B_2         : std_logic;
   signal clk80B_3         : std_logic;
   signal clk80B_4         : std_logic;
   signal gnd              : std_logic;
   signal readout_data_out : std_logic_vector(7 downto 0);
   signal rso_dly          : std_logic_vector(31 downto 0);
   signal rso_start_out    : STD_LOGIC;
   signal rso_start_raw    : std_logic;
   signal transfer_en      : std_logic;
   signal trig_sync        : std_logic;
   signal trigdly          : std_logic;
   signal vdd              : std_logic;

   -- Implicit buffer signal declarations
   signal frame_sync_out_internal   : STD_ULOGIC;
   signal readout_sync_out_internal : STD_ULOGIC;


   -- ModuleWare signal declarations for instance 'I9' of 'mux2'
   signal MW_I9din0l : std_logic;
   signal MW_I9din1l : std_logic;

   -- Component Declarations
   component FDDRCPE
   port (
      C0  : in     STD_ULOGIC;
      C1  : in     STD_ULOGIC;
      CE  : in     STD_ULOGIC;
      CLR : in     STD_ULOGIC;
      D0  : in     STD_ULOGIC;
      D1  : in     STD_ULOGIC;
      PRE : in     STD_ULOGIC;
      Q   : out    STD_ULOGIC
   );
   end component;
   component comm_hs
   port (
      clk80            : in     STD_ULOGIC ;
      frame_sync_out   : in     STD_ULOGIC ;
      readout_sync_in  : in     std_logic ;
      readout_sync_out : in     STD_ULOGIC ;
      rst              : in     std_logic ;
      transfer_en      : out    std_logic 
   );
   end component;
   component counter_delay
   generic (
      WIDTH : integer := 32
   );
   port (
      clk         : in     std_logic ;
      delay       : in     std_logic_vector ((WIDTH-1) downto 0);
      reset       : in     std_logic ;
      sig         : in     std_logic ;
      delayed_sig : out    std_logic 
   );
   end component;
   component data_mux_matt
   port (
      addr             : in     std_logic_vector (9 downto 0);
      clk40            : in     std_logic ;
      clk40d           : in     std_logic ;
      clk80            : in     STD_ULOGIC ;
      db_in            : in     std_logic_vector (31 downto 0);
      db_rd            : in     std_logic ;
      db_wr            : in     std_logic ;
      fifo_data_count  : in     std_logic_VECTOR (9 downto 0);
      fifo_data_out    : in     std_logic_vector (31 downto 0);
      fifo_empty       : in     std_logic ;
      readout_sync_in  : in     std_logic ;
      rst              : in     std_logic ;
      transfer_en      : in     std_logic ;
      db_out           : out    std_logic_vector (31 downto 0);
      fifo_rd          : out    std_logic ;
      readout_data_out : out    std_logic_vector (7 downto 0)
   );
   end component;
   component dlyd_frame_sync
   port (
      addr      : in     std_logic_vector (9 downto 0);
      clk40     : in     std_logic ;
      clk40d    : in     std_logic ;
      db_in     : in     std_logic_vector (31 downto 0);
      db_rd     : in     std_logic ;
      db_wr     : in     std_logic ;
      rst       : in     std_logic ;
      trig_sync : in     std_logic ;
      db_out    : out    std_logic_vector (31 downto 0);
      trigdly   : out    std_logic 
   );
   end component;
   component edgedet
   port (
      clk     : in     std_logic ;
      rst     : in     std_logic ;
      sig     : in     std_logic ;
      rising  : out    std_logic ;
      falling : out    std_logic 
   );
   end component;
   component frm_sync_out
   port (
      clk40          : in     std_logic ;
      rst            : in     std_logic ;
      trigdly        : in     std_logic ;
      frame_sync_out : out    STD_ULOGIC 
   );
   end component;
   component readout_reg
   generic (
      ADDRESS : integer := 0
   );
   port (
      addr   : in     std_logic_vector (9 downto 0);
      clk    : in     std_logic ;
      db_in  : in     std_logic_vector (31 downto 0);
      db_rd  : in     std_logic ;
      db_wr  : in     std_logic ;
      rst    : in     std_logic ;
      db_out : out    std_logic_vector (31 downto 0);
      reg    : out    std_logic_vector (31 downto 0)
   );
   end component;
   component readout_spy
   port (
      clk80           : in     STD_ULOGIC ;
      readout_sync_in : in     std_logic ;
      rst             : in     std_logic ;
      trig_sync       : in     std_logic ;
      syncin_detected : out    std_logic 
   );
   end component;
   component readout_sync_mc
   port (
      HOLD_INT         : in     std_logic ;
      clk40            : in     std_logic ;
      fifo_data_count  : in     std_logic_VECTOR (9 downto 0);
      rst              : in     std_logic ;
      readout_sync_out : out    STD_ULOGIC 
   );
   end component;

   -- Optional embedded configurations
   -- pragma synthesis_off
   for all : FDDRCPE use entity unisim.FDDRCPE;
   for all : comm_hs use entity CERC_FE_FPGA.comm_hs;
   for all : counter_delay use entity CERC_FE_FPGA.counter_delay;
   for all : data_mux_matt use entity CERC_FE_FPGA.data_mux_matt;
   for all : dlyd_frame_sync use entity CERC_FE_FPGA.dlyd_frame_sync;
   for all : edgedet use entity CERC_FE_FPGA.edgedet;
   for all : frm_sync_out use entity CERC_FE_FPGA.frm_sync_out;
   for all : readout_reg use entity CERC_FE_FPGA.readout_reg;
   for all : readout_spy use entity CERC_FE_FPGA.readout_spy;
   for all : readout_sync_mc use entity CERC_FE_FPGA.readout_sync_mc;
   -- pragma synthesis_on


begin

   -- ModuleWare code for instance 'I27' of 'vdd'
      vdd <= '1';

   -- ModuleWare code for instance 'I29' of 'inv'
      clk80B_1 <= not(clk80);

   -- ModuleWare code for instance 'I30' of 'inv'
      clk80B_2 <= not(clk80);

   -- ModuleWare code for instance 'I33' of 'gnd'
      gnd <= '0';

   -- ModuleWare code for instance 'I31' of 'inv'
      clk80B_3 <= not(clk80);

   -- ModuleWare code for instance 'I32' of 'inv'
      clk80B_4 <= not(clk80);

   -- ModuleWare code for instance 'I9' of 'mux2'
   
   I9combo: process (MW_I9din0l, MW_I9din1l, fkev_mode)
   variable dtemp : std_logic;
   begin
      case fkev_mode is
      when '0' => dtemp := MW_I9din0l;
      when '1' => dtemp := MW_I9din1l;
      when others => dtemp := 'X';
      end case;
      rso_start_raw <= dtemp;
   end process I9combo;
   MW_I9din0l <= trig_sync;
   MW_I9din1l <= fkev_busy;
   -- Instance port mappings.
   I0 : FDDRCPE
      port map (
         Q   => ser_data_out(0),
         C0  => clk80,
         C1  => clk80B_1,
         CE  => vdd,
         D0  => readout_data_out(4),
         D1  => readout_data_out(0),
         CLR => rst,
         PRE => gnd
      );
   I1 : FDDRCPE
      port map (
         Q   => ser_data_out(1),
         C0  => clk80,
         C1  => clk80B_2,
         CE  => vdd,
         D0  => readout_data_out(5),
         D1  => readout_data_out(1),
         CLR => rst,
         PRE => gnd
      );
   I2 : FDDRCPE
      port map (
         Q   => ser_data_out(2),
         C0  => clk80,
         C1  => clk80B_3,
         CE  => vdd,
         D0  => readout_data_out(6),
         D1  => readout_data_out(2),
         CLR => rst,
         PRE => gnd
      );
   I3 : FDDRCPE
      port map (
         Q   => ser_data_out(3),
         C0  => clk80,
         C1  => clk80B_4,
         CE  => vdd,
         D0  => readout_data_out(7),
         D1  => readout_data_out(3),
         CLR => rst,
         PRE => gnd
      );
   I8 : comm_hs
      port map (
         clk80            => clk80,
         frame_sync_out   => frame_sync_out_internal,
         readout_sync_in  => readout_sync_in,
         readout_sync_out => readout_sync_out_internal,
         rst              => rst,
         transfer_en      => transfer_en
      );
   I12 : counter_delay
      generic map (
         WIDTH => 32
      )
      port map (
         clk         => clk40,
         delay       => rso_dly,
         reset       => rst,
         sig         => rso_start_raw,
         delayed_sig => rso_start_out
      );
   I7 : data_mux_matt
      port map (
         addr             => addr,
         clk40            => clk40,
         clk40d           => clk40d,
         clk80            => clk80,
         db_in            => db_in,
         db_rd            => db_rd,
         db_wr            => db_wr,
         fifo_data_count  => fifo_data_count,
         fifo_data_out    => fifo_data_out,
         fifo_empty       => fifo_empty,
         readout_sync_in  => readout_sync_in,
         rst              => rst,
         transfer_en      => transfer_en,
         db_out           => db_out,
         fifo_rd          => fifo_rd,
         readout_data_out => readout_data_out
      );
   I4 : dlyd_frame_sync
      port map (
         addr      => addr,
         clk40     => clk40,
         clk40d    => clk40d,
         db_in     => db_in,
         db_rd     => db_rd,
         db_wr     => db_wr,
         rst       => rst,
         trig_sync => trig_sync,
         db_out    => db_out,
         trigdly   => trigdly
      );
   I11 : edgedet
      port map (
         clk     => clk40,
         rst     => rst,
         sig     => trigger,
         rising  => open,
         falling => trig_sync
      );
   I5 : frm_sync_out
      port map (
         clk40          => clk40,
         rst            => rst,
         trigdly        => trigdly,
         frame_sync_out => frame_sync_out_internal
      );
   I13 : readout_reg
      generic map (
         ADDRESS => 36
      )
      port map (
         addr   => addr,
         clk    => clk40d,
         db_in  => db_in,
         db_rd  => db_rd,
         db_wr  => db_wr,
         rst    => rst,
         db_out => db_out,
         reg    => rso_dly
      );
   I10 : readout_spy
      port map (
         clk80           => clk80,
         readout_sync_in => readout_sync_in,
         rst             => rst,
         trig_sync       => trig_sync,
         syncin_detected => syncin_detected
      );
   I6 : readout_sync_mc
      port map (
         HOLD_INT         => rso_start_out,
         clk40            => clk40,
         fifo_data_count  => fifo_data_count,
         rst              => rst,
         readout_sync_out => readout_sync_out_internal
      );

   -- Implicit buffered output assignments
   frame_sync_out   <= frame_sync_out_internal;
   readout_sync_out <= readout_sync_out_internal;

end struct;
