-- hds header_start
--
-- VHDL Architecture CERC_FE_FPGA.comms_tester.rtl
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 19:55:08 03/09/06
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;
use ieee.numeric_std.ALL;
use ieee.std_logic_textio.ALL;

entity comms_tester is
   port( 
      db_out           : in     std_logic_vector (31 downto 0);
      fifo_rd          : in     std_logic;
      frame_sync_out   : in     STD_ULOGIC;
      readout_sync_out : in     STD_ULOGIC;
      ser_data_out     : in     std_logic_vector (3 downto 0);
      syncin_detected  : in     std_logic;
      addr             : out    std_logic_vector (9 downto 0);
      clk40            : out    std_logic;
      clk80            : out    STD_ULOGIC;
      db_in            : out    std_logic_vector (31 downto 0);
      db_rd            : out    std_logic;
      db_wr            : out    std_logic;
      fifo_data_count  : out    std_logic_VECTOR (9 downto 0);
      fifo_data_out    : out    std_logic_vector (31 downto 0);
      fifo_empty       : out    std_logic;
      fifo_full        : out    std_logic;
      fkev_busy        : out    std_logic;
      fkev_mode        : out    std_logic;
      readout_sync_in  : out    std_logic;
      rst              : out    std_logic;
      trigger          : out    std_logic
   );

-- Declarations

end comms_tester ;


-- hds interface_end

architecture test of comms_tester is
constant CLKPERIOD	: time := 12500 ps;

	signal 	clkosc80	: std_logic := '1';
	signal 	clkosc40		: std_logic := '1';

begin
	
	-- clock generator
	------------------
	clkosc80	<= not clkosc80 after CLKPERIOD/2;
	clkosc40	<= not clkosc40 after CLKPERIOD;
	
	clk80		<= clkosc80;
	clk40		<= clkosc40;
	
	
	-- Unused sigs
	fkev_busy <= '0';
	fkev_mode <= '0';        	
	
	-- auto kick off 
	readout_sync_in  <= readout_sync_out after 1000 ns;
	
			
	sim : process
	begin
	
		addr 	<= "0000000000";
		db_in <= "00000000000000000000000000000000";
	  	db_rd <= '0';
		db_wr <= '0';

		fifo_data_count <= conv_std_logic_vector(125,10);
	   fifo_data_out   <= conv_std_logic_vector(16#12345678#,32);
		fifo_empty 		 <= '0';
		fifo_full  		 <= '0';

		--readout_sync_in  <= '0';
		trigger          <= '0';
				
		----------------------------------------------------------
		rst <= '1';
		wait for 100 ns;
		rst <= '0';
	
		--------------------------------------	
		wait for 100 ns;
		
		-- framesync out delay
		addr 	<= conv_std_logic_vector(34,10);
		db_in	<= conv_std_logic_vector(2,32);
		db_wr	<= '1';
		wait for 25 ns;
		db_wr	<= '0';
		wait for 100 ns;
		
		-- qdr_data_out  delay
		addr 	<= conv_std_logic_vector(35,10);
		db_in	<= conv_std_logic_vector(1,32);
		db_wr	<= '1';
		wait for 25 ns;
		db_wr			<= '0';
		wait for 100 ns;
		
		-- readout_sync_out delay
		addr 	<= conv_std_logic_vector(36,10);
		db_in	<= conv_std_logic_vector(252,32);
		db_wr	<= '1';
		wait for 25 ns;
		db_wr	<= '0';
		wait for 100 ns;
		
		
		wait for 210 ns;	
	
		trigger 	<= '1';
		wait for 65 ns;
		trigger	<= '0';
		
		wait;
	
	end process;
end test;
