-- hds header_start
--
-- VHDL Entity CERC_FE_FPGA.fe_system.symbol
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 09:04:36 02/10/06
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end

LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;


entity fe_system is
   port( 
      LOCKED          : in     std_logic;
      addr            : in     std_logic_vector (9 downto 0);
      clk             : in     std_logic;
      clk40d          : in     std_logic;
      db_in           : in     std_logic_vector (31 downto 0);
      db_rd           : in     std_logic;
      db_wr           : in     std_logic;
      event_data      : in     std_logic_vector (31 downto 0);
      event_wr        : in     std_logic;
      fakev_reg_en    : in     std_logic;
      fifo_rd         : in     std_logic;
      fifo_rstH       : in     std_logic;
      src_id          : in     std_logic_vector (2 downto 0);
      trig_ext_i      : in     std_logic;
      trig_reg_en     : in     std_logic;
      db_out          : out    std_logic_vector (31 downto 0);
      fifo_data_count : out    std_logic_VECTOR (9 downto 0);
      fifo_data_out   : out    std_logic_vector (31 downto 0);
      fifo_empty      : out    std_logic;
      fifo_full       : out    std_logic;
      fkev_busy       : out    std_logic;
      fkev_mode       : out    std_logic;
      trig_data_reg   : out    std_logic_vector (31 downto 0)
   );

-- Declarations

end fe_system ;


-- hds interface_end

--
-- VHDL Architecture CERC_FE_FPGA.fe_system.struct
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 09:04:42 02/10/06
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--

LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

library CERC_FE_FPGA;
library unisim;

architecture struct of fe_system is

   -- Architecture declarations

   -- Internal signal declarations
   signal addr_count     : std_logic_vector(9 downto 0);
   signal addr_int       : std_logic_vector(9 downto 0);
   signal fifo_data_in   : std_logic_VECTOR(31 downto 0);
   signal fifo_data_in1  : std_logic_VECTOR(31 downto 0);
   signal fifowr_en      : std_logic;
   signal fkev_length    : std_logic_vector(9 downto 0);
   signal fkev_ram_dout  : std_logic_VECTOR(31 downto 0);
   signal fkev_to_fifo   : std_logic;
   signal fkev_trig      : std_logic;
   signal fkevbusy_clkd  : std_logic;
   signal hdr_data       : std_logic_vector(31 downto 0);
   signal hdr_select     : std_logic;
   signal hdr_wr         : std_logic;
   signal one            : std_logic;
   signal ram_addr       : std_logic_vector(9 downto 0);
   signal ram_db_out_en  : std_logic;
   signal ram_en_all     : std_logic;
   signal reg_fkev_ctrl  : std_logic_vector(31 downto 0);
   signal rst            : std_logic;
   signal rst_fifo       : std_logic;
   signal trig_fall_edge : std_logic;
   signal trigger        : std_logic;
   signal trigq          : STD_ULOGIC;
   signal zero           : std_logic;

   -- Implicit buffer signal declarations
   signal fifo_full_internal       : std_logic;
   signal fifo_empty_internal      : std_logic;
   signal fifo_data_count_internal : std_logic_VECTOR (9 downto 0);
   signal trig_data_reg_internal   : std_logic_vector (31 downto 0);
   signal fkev_mode_internal       : std_logic;
   signal fkev_busy_internal       : std_logic;


   -- Component Declarations
   component FDC
   port (
      C   : in     STD_ULOGIC;
      CLR : in     STD_ULOGIC;
      D   : in     STD_ULOGIC;
      Q   : out    STD_ULOGIC
   );
   end component;
   component cg_fifo1kx32_new
   port (
      clk        : in     std_logic ;
      sinit      : in     std_logic ;
      din        : in     std_logic_VECTOR (31 downto 0);
      wr_en      : in     std_logic ;
      rd_en      : in     std_logic ;
      dout       : out    std_logic_VECTOR (31 downto 0);
      full       : out    std_logic ;
      empty      : out    std_logic ;
      data_count : out    std_logic_VECTOR (9 downto 0)
   );
   end component;
   component cg_ram1kx32_new
   port (
      addr : in     std_logic_VECTOR (9 downto 0);
      clk  : in     std_logic ;
      din  : in     std_logic_VECTOR (31 downto 0);
      dout : out    std_logic_VECTOR (31 downto 0);
      en   : in     std_logic ;
      we   : in     std_logic 
   );
   end component;
   component edgedet
   port (
      clk     : in     std_logic ;
      rst     : in     std_logic ;
      sig     : in     std_logic ;
      rising  : out    std_logic ;
      falling : out    std_logic 
   );
   end component;
   component fkev_counter
   port (
      clk       : in     std_logic ;
      rst       : in     std_logic ;
      start     : in     std_logic ;
      enable    : in     std_logic ;
      count_o   : out    std_logic_vector (9 downto 0);
      busy_o    : out    std_logic ;
      count_max : in     std_logic_vector (9 downto 0)
   );
   end component;
   component fkev_router
   port (
      clk40d          : in     std_logic ;
      fifo_data_count : in     std_logic_VECTOR (9 downto 0);
      fifo_empty      : in     std_logic ;
      fifo_full       : in     std_logic ;
      fkev_mode       : in     std_logic ;
      rst             : in     std_logic ;
      src_id          : in     std_logic_vector (2 downto 0);
      trig_data_reg   : in     std_logic_vector (31 downto 0);
      trig_fall_edge  : in     std_logic ;
      fkev_trig       : out    std_logic ;
      hdr_data        : out    std_logic_vector (31 downto 0);
      hdr_select      : out    std_logic ;
      hdr_wr          : out    std_logic 
   );
   end component;
   component m_and2
   port (
      I1 : in     std_logic ;
      I2 : in     std_logic ;
      O  : out    std_logic 
   );
   end component;
   component m_dff
   port (
      D   : in     std_logic ;
      clk : in     std_logic ;
      rst : in     std_logic ;
      Q   : out    std_logic 
   );
   end component;
   component m_mux2
   port (
      I0  : in     std_logic ;
      SEL : in     std_logic ;
      O   : out    std_logic ;
      I1  : in     std_logic 
   );
   end component;
   component m_mux2_10
   port (
      I0  : in     std_logic_vector (9 downto 0);
      SEL : in     std_logic ;
      O   : out    std_logic_vector (9 downto 0);
      I1  : in     std_logic_vector (9 downto 0)
   );
   end component;
   component register32
   generic (
      RESET_VAL : integer := 0
   );
   port (
      clk    : in     std_logic ;
      db_out : out    std_logic_vector (31 downto 0);
      en_i   : in     std_logic ;
      rd_i   : in     std_logic ;
      rst    : in     std_logic ;
      wr_i   : in     std_logic ;
      reg_o  : out    std_logic_vector (31 downto 0);
      db_in  : in     std_logic_vector (31 downto 0)
   );
   end component;
   component trig_count_reg
   port (
      clk    : in     std_logic ;
      rst    : in     std_logic ;
      sig    : in     std_logic ;
      wr_en  : in     std_logic ;
      db_out : out    std_logic_vector (31 downto 0)
   );
   end component;

   -- ModuleWare Component Declarations
   component inv_36D90179
   port (
      din  : in     std_logic;
      dout : out    std_logic
   );
   end component;
   component mux2_38187C8A
   port (
      din0 : in     std_logic_vector (31 downto 0);
      din1 : in     std_logic_vector (31 downto 0);
      sel  : in     std_logic;
      dout : out    std_logic_vector (31 downto 0)
   );
   end component;
   component tribuf_3E7467B8
   port (
      din  : in     std_logic_vector (31 downto 0);
      ena  : in     std_logic;
      dout : out    std_logic_vector (31 downto 0)
   );
   end component;

   -- Optional embedded configurations
   -- pragma synthesis_off
   for all : FDC use entity unisim.FDC;
   for all : cg_fifo1kx32_new use entity CERC_FE_FPGA.cg_fifo1kx32_new;
   for all : cg_ram1kx32_new use entity CERC_FE_FPGA.cg_ram1kx32_new;
   for all : edgedet use entity CERC_FE_FPGA.edgedet;
   for all : fkev_counter use entity CERC_FE_FPGA.fkev_counter;
   for all : fkev_router use entity CERC_FE_FPGA.fkev_router;
   for all : m_and2 use entity CERC_FE_FPGA.m_and2;
   for all : m_dff use entity CERC_FE_FPGA.m_dff;
   for all : m_mux2 use entity CERC_FE_FPGA.m_mux2;
   for all : m_mux2_10 use entity CERC_FE_FPGA.m_mux2_10;
   for all : register32 use entity CERC_FE_FPGA.register32;
   for all : trig_count_reg use entity CERC_FE_FPGA.trig_count_reg;
   -- pragma synthesis_on

   -- ModuleWare embedded configurations
   -- pragma synthesis_off
   for all : inv_36D90179 use entity CERC_FE_FPGA.inv_36D90179;
   for all : mux2_38187C8A use entity CERC_FE_FPGA.mux2_38187C8A;
   for all : tribuf_3E7467B8 use entity CERC_FE_FPGA.tribuf_3E7467B8;
   -- pragma synthesis_on


begin
   -- Architecture concurrent statements
   -- HDL Embedded Text Block 1 eb2
   -- eb2 1                                        
   addr_int <= "0" & addr(8 downto 0);

   -- HDL Embedded Text Block 2 eb3
   -- eb3 2                                        
   fifowr_en <= ((event_wr and (not fkev_mode_internal)) xor fkevbusy_clkd) or hdr_wr;

   -- HDL Embedded Text Block 3 eb1
   -- eb1 3         
   
   fkev_to_fifo <= not ram_db_out_en and not event_wr and fkev_mode_internal;

   -- HDL Embedded Text Block 4 fkev_ctrl_map
   -- fkev_ctrl_map
   fkev_mode_internal   <= reg_fkev_ctrl(15);
   fkev_length <= reg_fkev_ctrl(9 downto 0);


   -- ModuleWare code for instance 'I9' of 'vdd'
      one <= '1';

   -- ModuleWare code for instance 'I8' of 'gnd'
      zero <= '0';

   -- ModuleWare code for instance 'I3' of 'or2'
      rst_fifo <= rst or fifo_rstH;
   -- Instance port mappings.
   I24 : FDC
      port map (
         Q   => trigq,
         C   => clk,
         CLR => rst,
         D   => trig_ext_i
      );
   I25 : FDC
      port map (
         Q   => trigger,
         C   => clk,
         CLR => rst,
         D   => trigq
      );
   I26 : cg_fifo1kx32_new
      port map (
         clk        => clk,
         sinit      => rst_fifo,
         din        => fifo_data_in,
         wr_en      => fifowr_en,
         rd_en      => fifo_rd,
         dout       => fifo_data_out,
         full       => fifo_full_internal,
         empty      => fifo_empty_internal,
         data_count => fifo_data_count_internal
      );
   I5 : cg_ram1kx32_new
      port map (
         addr => ram_addr,
         clk  => clk40d,
         din  => db_in,
         dout => fkev_ram_dout,
         en   => ram_en_all,
         we   => db_wr
      );
   I7 : edgedet
      port map (
         clk     => clk,
         rst     => rst,
         sig     => trigger,
         rising  => open,
         falling => trig_fall_edge
      );
   I18 : fkev_counter
      port map (
         clk       => clk,
         rst       => rst,
         start     => fkev_trig,
         enable    => fkev_mode_internal,
         count_o   => addr_count,
         busy_o    => fkev_busy_internal,
         count_max => fkev_length
      );
   I4 : fkev_router
      port map (
         clk40d          => clk40d,
         fifo_data_count => fifo_data_count_internal,
         fifo_empty      => fifo_empty_internal,
         fifo_full       => fifo_full_internal,
         fkev_mode       => fkev_mode_internal,
         rst             => rst,
         src_id          => src_id,
         trig_data_reg   => trig_data_reg_internal,
         trig_fall_edge  => trig_fall_edge,
         fkev_trig       => fkev_trig,
         hdr_data        => hdr_data,
         hdr_select      => hdr_select,
         hdr_wr          => hdr_wr
      );
   I19 : m_and2
      port map (
         I1 => addr(9),
         I2 => db_rd,
         O  => ram_db_out_en
      );
   I11 : m_dff
      port map (
         D   => fkev_busy_internal,
         clk => clk40d,
         rst => rst,
         Q   => fkevbusy_clkd
      );
   I15 : m_mux2
      port map (
         I0  => addr(9),
         SEL => fkev_mode_internal,
         O   => ram_en_all,
         I1  => fkev_busy_internal
      );
   I14 : m_mux2_10
      port map (
         I0  => addr_int,
         SEL => fkev_mode_internal,
         O   => ram_addr,
         I1  => addr_count
      );
   I22 : register32
      generic map (
         RESET_VAL => 0
      )
      port map (
         clk    => clk,
         db_out => db_out,
         en_i   => fakev_reg_en,
         rd_i   => db_rd,
         rst    => rst,
         wr_i   => db_wr,
         reg_o  => reg_fkev_ctrl,
         db_in  => db_in
      );
   I12 : trig_count_reg
      port map (
         clk    => clk,
         rst    => rst,
         sig    => trigger,
         wr_en  => trig_reg_en,
         db_out => trig_data_reg_internal
      );

   -- ModuleWare instance port mappings.
   I1 : inv_36D90179
      port map (
         din  => LOCKED,
         dout => rst
      );

   I10 : mux2_38187C8A
      port map (
         din0 => fifo_data_in1,
         din1 => hdr_data,
         sel  => hdr_select,
         dout => fifo_data_in
      );

   I2 : mux2_38187C8A
      port map (
         din0 => event_data,
         din1 => fkev_ram_dout,
         sel  => fkev_mode_internal,
         dout => fifo_data_in1
      );

   I0 : tribuf_3E7467B8
      port map (
         din  => fkev_ram_dout,
         ena  => ram_db_out_en,
         dout => db_out
      );


   -- Implicit buffered output assignments
   fifo_full       <= fifo_full_internal;
   fifo_empty      <= fifo_empty_internal;
   fifo_data_count <= fifo_data_count_internal;
   trig_data_reg   <= trig_data_reg_internal;
   fkev_mode       <= fkev_mode_internal;
   fkev_busy       <= fkev_busy_internal;

end struct;
