-- hds header_start
--
-- VHDL Entity CERC_FE_FPGA.fkev_router.interface
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 09:04:36 02/10/06
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end

LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity fkev_router is
   port( 
      clk40d          : in     std_logic;
      fifo_data_count : in     std_logic_VECTOR (9 downto 0);
      fifo_empty      : in     std_logic;
      fifo_full       : in     std_logic;
      fkev_mode       : in     std_logic;
      rst             : in     std_logic;
      src_id          : in     std_logic_vector (2 downto 0);
      trig_data_reg   : in     std_logic_vector (31 downto 0);
      trig_fall_edge  : in     std_logic;
      fkev_trig       : out    std_logic;
      hdr_data        : out    std_logic_vector (31 downto 0);
      hdr_select      : out    std_logic;
      hdr_wr          : out    std_logic
   );

-- Declarations

end fkev_router ;


-- hds interface_end

--
-- VHDL Architecture CERC_FE_FPGA.fkev_router.fsm
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 09:04:36 02/10/06
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

architecture fsm of fkev_router is

   -- Architecture Declarations
   type state_type is (
      s0,
      s1,
      s3,
      s2
   );

   -- State vector declaration
   attribute state_vector : string;
   attribute state_vector of fsm : architecture is "current_state" ;


   -- Declare current and next state signals
   signal current_state : state_type ;
   signal next_state : state_type ;

   -- Declare any pre-registered internal signals
   signal fkev_trig_int : std_logic  ;
   signal hdr_data_int : std_logic_vector (31 downto 0) ;
   signal hdr_select_int : std_logic  ;
   signal hdr_wr_int : std_logic  ;

begin

   ----------------------------------------------------------------------------
   clocked : process(
      clk40d,
      rst
   )
   ----------------------------------------------------------------------------
   begin
      if (rst = '1') then
         current_state <= s0;
         -- Reset Values
         fkev_trig <= '0';
         hdr_data <= "00000000000000000000000000000000";
         hdr_select <= '0';
         hdr_wr <= '0';
      elsif (clk40d'event and clk40d = '1') then
         current_state <= next_state;
         -- Registered output assignments
         fkev_trig <= fkev_trig_int;
         hdr_data <= hdr_data_int;
         hdr_select <= hdr_select_int;
         hdr_wr <= hdr_wr_int;

         -- Default Assignment To Internals

      end if;

   end process clocked;

   ----------------------------------------------------------------------------
   nextstate : process (
      current_state,
      trig_fall_edge
   )
   ----------------------------------------------------------------------------
   begin
      case current_state is
      when s0 =>
         if (trig_fall_edge ='1') then
            next_state <= s1;
         else
            next_state <= s0;
         end if;
      when s1 =>
            next_state <= s2;
      when s3 =>
            next_state <= s0;
      when s2 =>
            next_state <= s3;
      when others =>
         next_state <= s0;
      end case;

   end process nextstate;

   ----------------------------------------------------------------------------
   output : process (
      current_state,
      fifo_data_count,
      fifo_empty,
      fifo_full,
      src_id,
      trig_data_reg
   )
   ----------------------------------------------------------------------------
   begin
      -- Default Assignment
      fkev_trig_int <= '0';
      hdr_data_int <= "00000000000000000000000000000000";
      hdr_select_int <= '0';
      hdr_wr_int <= '0';
      -- Default Assignment To Internals

      -- Combined Actions
      case current_state is
      when s0 =>
         fkev_trig_int <='0';
         hdr_wr_int <= '0';
         hdr_select_int <= '0';
         hdr_data_int (2 downto 0) <= src_id;
         hdr_data_int(17 downto 8) <= fifo_data_count;
         hdr_data_int(24) <= fifo_empty;
         hdr_data_int(25) <= fifo_full;
         hdr_data_int (31 downto 26) <= (others => '0') ;
      when s1 =>
         hdr_wr_int <='1';
         hdr_select_int <= '1';
         fkev_trig_int <='0';
         hdr_data_int (2 downto 0) <= src_id;
         hdr_data_int(17 downto 8) <= fifo_data_count;
         hdr_data_int(24) <= fifo_empty;
         hdr_data_int(25) <= fifo_full;
         hdr_data_int (31 downto 26) <= (others => '0') ;
      when s3 =>
         hdr_wr_int <='0';
         fkev_trig_int <='1';
         hdr_select_int <='0';
      when s2 =>
         hdr_data_int <= trig_data_reg ;
         fkev_trig_int <='0';
         hdr_wr_int <='1';
         hdr_select_int <= '1';
      when others =>
         null;
      end case;

   end process output;

   -- Concurrent Statements

end fsm;
