-- hds header_start
--
-- VHDL Entity CERC_FE_FPGA.frm_sync_out.symbol
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 09:04:14 02/10/06
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end

LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;
USE ieee.std_logic_unsigned.ALL;

entity frm_sync_out is
   port( 
      clk40          : in     std_logic;
      rst            : in     std_logic;
      trigdly        : in     std_logic;
      frame_sync_out : out    STD_ULOGIC
   );

-- Declarations

end frm_sync_out ;


-- hds interface_end

--
-- VHDL Architecture CERC_FE_FPGA.frm_sync_out.fsm
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 09:04:14 02/10/06
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;
USE ieee.numeric_std.all;
USE ieee.std_logic_unsigned.ALL;

architecture fsm of frm_sync_out is

   -- Architecture Declarations
   signal count_int : std_logic_vector(6 downto 0);
   signal pattern_reg : std_logic_vector(80 downto 0);

   type state_type is (
      s0,
      s1,
      s2
   );


   -- Declare current and next state signals
   signal current_state : state_type ;
   signal next_state : state_type ;

begin

   ----------------------------------------------------------------------------
   clocked : process(
      clk40
   )
   ----------------------------------------------------------------------------
   begin
      if (clk40'event and clk40 = '1') then
         if (rst = '1') then
            current_state <= s0;
            -- Reset Values
            count_int <= "0000000";
            pattern_reg <= "1"&"00000001"&"00000010"&"00000011"&"00000100"&"00000101"&"00000110"&"00000111"&"00001000"&"00001001"&"00001010";
         else
            current_state <= next_state;
            -- Default Assignment To Internals
            count_int <= "0000000";
            pattern_reg <= "1"&"00000001"&"00000010"&"00000011"&"00000100"&"00000101"&"00000110"&"00000111"&"00001000"&"00001001"&"00001010";

            -- Combined Actions for internal signals only
            case current_state is
            when s0 =>
               count_int <= "1010001";
               pattern_reg <= "1"&"00000001"&"00000010"&"00000011"&"00000100"&"00000101"&"00000110"&"00000111"&"00001000"&"00001001"&"00001010";
            when s1 =>
               count_int <= "1010001";
               pattern_reg <= "1"&"00000001"&"00000010"&"00000011"&"00000100"&"00000101"&"00000110"&"00000111"&"00001000"&"00001001"&"00001010";
            when s2 =>
               count_int <=count_int - 1;
                pattern_reg <=  pattern_reg(79 downto 0) & '0';
            when others =>
               null;
            end case;

         end if;
      end if;

   end process clocked;

   ----------------------------------------------------------------------------
   nextstate : process (
      count_int,
      current_state,
      trigdly
   )
   ----------------------------------------------------------------------------
   begin
      case current_state is
      when s0 =>
         if (trigdly='1') then
            next_state <= s1;
         else
            next_state <= s0;
         end if;
      when s1 =>
         if (trigdly ='0') then
            next_state <= s2;
         else
            next_state <= s1;
         end if;
      when s2 =>
         if (count_int="0000000") then
            next_state <= s0;
         else
            next_state <= s2;
         end if;
      when others =>
         next_state <= s0;
      end case;

   end process nextstate;

   ----------------------------------------------------------------------------
   output : process (
      current_state,
      pattern_reg
   )
   ----------------------------------------------------------------------------
   begin
      -- Default Assignment
      frame_sync_out <= '0';
      -- Default Assignment To Internals

      -- Combined Actions
      case current_state is
      when s0 =>
         frame_sync_out <='0';
      when s1 =>
         frame_sync_out <='0';
      when s2 =>
         frame_sync_out<= pattern_reg (80);
      when others =>
         null;
      end case;

   end process output;

   -- Concurrent Statements

end fsm;
