-- hds header_start
--
-- VHDL Architecture CERC_FE_FPGA.readout_reg.rtl
--
-- Created:
--          by - Osman Zorba.UNKNOWN (HEPPC185)
--          at - 17:11:44 10/13/04
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end

LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;
USE ieee.numeric_std.all;
USE ieee.std_logic_textio.all;
USE ieee.std_logic_unsigned.ALL;


entity readout_reg is
   generic( 
      ADDRESS : integer := 0
   );
   port( 
      addr   : in     std_logic_vector (9 downto 0);
      clk    : in     std_logic;
      db_in  : in     std_logic_vector (31 downto 0);
      db_rd  : in     std_logic;
      db_wr  : in     std_logic;
      rst    : in     std_logic;
      db_out : out    std_logic_vector (31 downto 0);
      reg    : out    std_logic_vector (31 downto 0)
   );

-- Declarations

end readout_reg ;


-- hds interface_end
ARCHITECTURE rtl OF readout_reg IS
signal reg1 : std_logic_vector (31 downto 0);


BEGIN

	first : process (clk)
	begin
 		if(clk'event and clk='1') then
	  		if (rst='1') then
	    		reg1 <= (others => '0');
				db_out <= (others => 'Z');
		
	
			elsif (addr = conv_std_logic_vector(ADDRESS, 10)) then
			
				if (db_wr='1') then
		   		reg1		<= db_in;
		   	end if;
		   	
	  		
	  			if(db_rd='1') then
		   		db_out 	<= reg1;
	  			else
		   		db_out <= (others => 'Z');
		   	end if;
	  		end if;
 		end if;
 	end process first;

 	reg <= reg1;

END rtl;
