-- hds header_start
--
-- VHDL Entity CERC_FE_FPGA.TCALIB_mc.interface
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 09:04:32 02/10/06
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end

LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;
USE ieee.numeric_std.all;
USE ieee.std_logic_unsigned.ALL;

entity TCALIB_mc is
   port( 
      CAL_ENABLE  : in     std_logic;
      CLK160      : in     std_logic;
      RESET       : in     std_logic;
      TRIG        : in     STD_ULOGIC;
      pulse_width : in     std_logic_vector (31 downto 0);
      TCALIB      : out    std_logic
   );

-- Declarations

end TCALIB_mc ;


-- hds interface_end

--
-- VHDL Architecture CERC_FE_FPGA.TCALIB_mc.fsm
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 09:04:32 02/10/06
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;
USE ieee.numeric_std.all;
USE ieee.std_logic_unsigned.ALL;

architecture fsm of TCALIB_mc is

   -- Architecture Declarations
   signal pulse_width_int : std_logic_vector(31 downto 0);

   type state_type is (
      s0,
      s2
   );

   -- State vector declaration
   attribute state_vector : string;
   attribute state_vector of fsm : architecture is "current_state" ;


   -- Declare current and next state signals
   signal current_state : state_type ;
   signal next_state : state_type ;

   -- Declare any pre-registered internal signals
   signal TCALIB_cld : std_logic  ;

begin

   ----------------------------------------------------------------------------
   clocked : process(
      CLK160
   )
   ----------------------------------------------------------------------------
   begin
      if (CLK160'event and CLK160 = '1') then
         if (RESET = '1') then
            current_state <= s0;
            -- Reset Values
            TCALIB_cld <= '0';
            pulse_width_int <= "00000000000000000000000000000000";
         else
            current_state <= next_state;
            -- Default Assignment To Internals
            pulse_width_int <= "00000000000000000000000000000000";
            TCALIB_cld <= '0';

            -- Combined Actions for internal signals only
            case current_state is
            when s0 =>
               TCALIB_cld <= '0';
               pulse_width_int <= pulse_width ;
            when s2 =>
               TCALIB_cld <='1';
               pulse_width_int <= pulse_width_int - 1;
            when others =>
               null;
            end case;

         end if;
      end if;

   end process clocked;

   ----------------------------------------------------------------------------
   nextstate : process (
      CAL_ENABLE,
      TRIG,
      current_state,
      pulse_width_int
   )
   ----------------------------------------------------------------------------
   begin
      case current_state is
      when s0 =>
         if (TRIG ='1' and CAL_ENABLE ='1') then
            next_state <= s2;
         elsif (TRIG ='0') then
            next_state <= s0;
         else
            next_state <= s0;
         end if;
      when s2 =>
         if (pulse_width_int ="00000000000000000000000000000000") then
            next_state <= s0;
         else
            next_state <= s2;
         end if;
      when others =>
         next_state <= s0;
      end case;

   end process nextstate;

   -- Concurrent Statements
   -- Clocked output assignments
   TCALIB <= TCALIB_cld;


end fsm;
