-- hds header_start
--
-- VHDL Architecture CERC_FE_FPGA.TRIG_dly_sigs_tester.test
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 12:52:17 03/09/06
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;


entity TRIG_dly_sigs_tester is
   port( 
      HOLD_INT      : in     std_logic;
      HOLD_OUT      : in     std_logic;
      db_out        : in     std_logic_vector (31 downto 0);
      trig_readout  : in     std_logic;
      A0            : out    std_logic;
      A1            : out    std_logic;
      CLK160        : out    std_logic;
      CONFIG_SELECT : out    std_logic;
      RESET         : out    std_logic;
      SET_DATA      : out    std_logic_vector (31 downto 0);
      TRIGIN        : out    std_logic;
      clk40         : out    std_logic;
      clk40d        : out    std_logic;
      rd            : out    std_logic;
      wr            : out    std_logic
   );

-- Declarations

end TRIG_dly_sigs_tester ;


-- hds interface_end

architecture test of TRIG_dly_sigs_tester is

	constant CLKPERIOD	: time := 6250 ps;

	signal 	clkosc160	: std_logic := '1';
	signal 	clkosc40		: std_logic := '1';

begin
	
	-- clock generator
	------------------
	clkosc160	<= not clkosc160 after CLKPERIOD/2;
	clkosc40		<= not clkosc40  after CLKPERIOD*2;
	
	CLK160	<= clkosc160;
	clk40		<= clkosc40;
	clk40d	<= not clkosc40;
	
	
	CONFIG_SELECT <= '1';
			
	sim : process
	begin
	
	
		wait for 12 ns;
	
		wr			<= '0';
		rd			<= '0';
		A1			<= '0';
		A0			<= '0';
		TRIGIN 	<= '0';
		
		
		
		
		RESET <= '1';
		wait for 25 ns;
		RESET <= '0';
		
		wait for 100 ns;
		
		-- hold delay
		A1			<= '0';
		A0			<= '0';
		SET_DATA <=conv_std_logic_vector(1000,32);
		wr			<= '1';
		wait for 25 ns;
		wr			<= '0';
		wait for 100 ns;
		
		-- hold duration
		A1			<= '0';
		A0			<= '1';
		SET_DATA <=conv_std_logic_vector(2000,32);
		wr			<= '1';
		wait for 25 ns;
		wr			<= '0';
		
		
		wait for 210 ns;	
	
		TRIGIN 	<= '1';
		wait for 65 ns;
		TRIGIN	<= '0';
		
		
		
		wait for 22000 ns;	
	
		wait for 10 ns;
	
		TRIGIN 	<= '1';
		wait for 65 ns;
		TRIGIN	<= '0';
		
			
		wait;
	
	end process;
end test;
