-- hds header_start
--
-- VHDL Architecture CERC_FE_FPGA.vfeMUX.rtl
--
-- Created:
--          by - Osman Zorba.UNKNOWN (HEPPC185)
--          at - 17:39:38 09/30/04
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end
LIBRARY ieee;
USE ieee.std_logic_1164.all;

ENTITY vfeMUX IS
   PORT( 
      CLK            : IN     std_logic;
      LD_ENABLE      : IN     std_logic;
      RST            : IN     std_logic;
      SET_DATA       : IN     std_logic_vector (31 DOWNTO 0);
      rd             : IN     std_logic;
      wr             : IN     std_logic;
      BOT_ADDRESS    : OUT    std_logic;
      BOT_GAIN_SW    : OUT    std_logic;
      BOT_VFE_ENABLE : OUT    std_logic_vector (5 DOWNTO 0);
      TOP_ADDRESS    : OUT    std_logic;
      TOP_GAIN_SW    : OUT    std_logic;
      TOP_VFE_ENABLE : OUT    std_logic_vector (5 DOWNTO 0);
      db_out         : OUT    std_logic_vector (31 DOWNTO 0)
   );

-- Declarations

END vfeMUX ;

-- hds interface_end
ARCHITECTURE rtl OF vfeMUX IS
signal      BOT_ADDRESS_int	    :   std_logic;
signal      BOT_GAIN_SW_int	    :   std_logic;
signal      BOT_VFE_ENABLE_int	:   std_logic_vector (5 DOWNTO 0);
signal      TOP_ADDRESS_int  	:   std_logic;
signal      TOP_GAIN_SW_int  	:   std_logic;
signal      TOP_VFE_ENABLE_int	:   std_logic_vector (5 DOWNTO 0);

BEGIN

VFEENABLE:process (CLK)
begin

    if(CLK'event and CLK='0') then
      if (RST = '1') then
       TOP_VFE_ENABLE_int <= "000000" after 10 ps;
       TOP_ADDRESS_int <= '0' after 10 ps;
       TOP_GAIN_SW_int <= '0' after 10 ps;
       BOT_VFE_ENABLE_int <= "000000" after 10 ps;
       BOT_ADDRESS_int <= '0' after 10 ps;
       BOT_GAIN_SW_int <= '0' after 10 ps;
      db_out <= (others => 'Z') after 10 ps;

      elsif(LD_ENABLE = '1' and wr='1') then
        TOP_VFE_ENABLE_int <= SET_DATA(5 downto 0) after 10 ps;
        BOT_VFE_ENABLE_int <= SET_DATA(11 downto 6) after 10 ps;
        TOP_ADDRESS_int <= SET_DATA(12) after 10 ps;
        TOP_GAIN_SW_int <= SET_DATA(13) after 10 ps;
        BOT_ADDRESS_int <= SET_DATA(14) after 10 ps;
        BOT_GAIN_SW_int <= SET_DATA(15) after 10 ps;

      elsif(LD_ENABLE = '1' and rd='1') then
        db_out(5 downto 0) <= TOP_VFE_ENABLE_int  after 10 ps;
        db_out(11 downto 6) <= BOT_VFE_ENABLE_int after 10 ps;
        db_out(12) <= TOP_ADDRESS_int  after 10 ps;
        db_out(13) <= TOP_GAIN_SW_int  after 10 ps;
        db_out(14) <= BOT_ADDRESS_int  after 10 ps;
        db_out(15) <= BOT_GAIN_SW_int  after 10 ps;
		db_out(31 downto 16) <= (others => '0') after 10 ps;

      elsif(LD_ENABLE = '0' or rd='0') then
        db_out <= (others => 'Z')  after 10 ps;

      end if ;
     end if;

end process VFEENABLE;

       TOP_VFE_ENABLE <= TOP_VFE_ENABLE_int after 10 ps;
       TOP_ADDRESS <= TOP_ADDRESS_int after 10 ps;
       TOP_GAIN_SW <= TOP_GAIN_SW_int after 10 ps ;
       BOT_VFE_ENABLE <= BOT_VFE_ENABLE_int  after 10 ps;
       BOT_ADDRESS <= BOT_ADDRESS_int after 10 ps ;
       BOT_GAIN_SW <= BOT_GAIN_SW_int after 10 ps ;
END rtl;
