-- hds header_start
--
-- VHDL Architecture CERC_FE_FPGA.VFEMUX_sigs_out.rtl
--
-- Created:
--          by - Osman Zorba.UNKNOWN (HEPPC185)
--          at - 15:14:17 10/01/04
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end
LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;
USE ieee.std_logic_unsigned.ALL;

ENTITY VFEMUX_sigs_out IS
   PORT( 
      A0            : IN     std_logic;
      A1            : IN     std_logic;
      CLK           : IN     std_logic;
      CONFIG_SELECT : IN     std_logic;
      MCOUNT        : IN     std_logic_vector (31 DOWNTO 0);
      MLD           : IN     std_logic;
      RESET         : IN     std_logic;
      SET_DATA      : IN     std_logic_vector (31 DOWNTO 0);
      rd            : IN     std_logic;
      wr            : IN     std_logic;
      VFEMUXCLK     : OUT    std_logic;
      db_out        : OUT    std_logic_vector (31 DOWNTO 0)
   );

-- Declarations

END VFEMUX_sigs_out ;

-- hds interface_end
ARCHITECTURE rtl OF VFEMUX_sigs_out IS
signal      mark          :     std_logic;
signal      mark1         :     std_logic;
signal      markcnt1      :     std_logic_vector (31 DOWNTO 0);
signal      muxclk        :     std_logic_vector (31 DOWNTO 0);
signal      muxclk1       :     std_logic_vector (31 DOWNTO 0);
signal      muxclkdata    :     std_logic_vector (31 DOWNTO 0);
signal      space         :     std_logic;
signal      space1        :     std_logic;
signal      spacecnt      :     std_logic_vector (31 DOWNTO 0);
signal      spacecnt1     :     std_logic_vector (31 DOWNTO 0);
signal      startcount    :     std_logic_vector (31 DOWNTO 0);
signal      tmp           :     std_logic_vector (31 DOWNTO 0);
signal      tmp1          :     std_logic_vector (31 DOWNTO 0);

BEGIN
config:process (CLK)

begin

  if (CLK'event and CLK='0') then
   if (RESET = '1') then 
        startcount <= (others => '0') after 10 ps;
        markcnt1 <= (others => '0') after 10 ps;
        tmp1 <= (others => '0') after 10 ps;
        spacecnt1 <= (others => '0') after 10 ps;
        muxclkdata <= (others => '0') after 10 ps;
        muxclk1 <= (others => '0') after 10 ps;
        mark1 <= '1' after 10 ps;
        db_out <= (others => 'Z') after 10 ps;
		space1 <='0' after 10 ps;

   elsif(CONFIG_SELECT = '1' and A0='0' and A1='0' and wr='1') then
        startcount <= SET_DATA after 10 ps;

   elsif(CONFIG_SELECT = '1' and A0='1' and A1 = '0' and wr='1') then
        markcnt1 <= SET_DATA after 10 ps;
        tmp1 <= SET_DATA after 10 ps;
        mark1 <= '1' after 10 ps;

   elsif(CONFIG_SELECT = '1' and A0='0' and A1 = '1' and wr='1') then
        spacecnt1 <= SET_DATA after 10 ps;

   elsif(CONFIG_SELECT = '1' and A0='1' and A1 = '1' and wr='1') then
        muxclkdata <= SET_DATA after 10 ps;
        muxclk1 <= SET_DATA after 10 ps;

   elsif(CONFIG_SELECT = '1' and A0='0' and A1='0' and rd='1') then
        db_out <= startcount after 10 ps ;

   elsif(CONFIG_SELECT = '1' and A0='1' and A1 = '0' and rd='1') then
        db_out <= markcnt1 after 10 ps ;

   elsif(CONFIG_SELECT = '1' and A0='0' and A1 = '1' and rd='1') then
        db_out <= spacecnt1 after 10 ps ;

   elsif(CONFIG_SELECT = '1' and A0='1' and A1 = '1' and rd='1') then
        db_out <= muxclkdata after 10 ps ;

   elsif(CONFIG_SELECT = '0' or rd = '0') then 
    db_out <= (others => 'Z') after 10 ps;
   end if;
 end if;
end process config;



first:process (CLK)

begin

  if (CLK'event and CLK='0') then
   if (RESET = '1') then 
        VFEMUXCLK <= '0' after 10 ps;
   	    mark <= '1' after 10 ps;
		space <='0' after 10 ps;
		tmp <= (others => '0') after 10 ps;
		muxclk <= (others => '0') after 10 ps;
		spacecnt<= (others => '0') after 10 ps;

   elsif(MLD = '1') then

     if(MCOUNT >= startcount) then

      if(muxclk > "00000000000000000000000000000000") then

       if(mark='1') then
        if(tmp > "00000000000000000000000000000000") then
          tmp <= (tmp - 1)  after 10 ps ;
          VFEMUXCLK <= '1' after 10 ps;
          space <='0' after 10 ps;
        else
          VFEMUXCLK <= '0' after 10 ps;
          mark <= '0' after 10 ps;
          space <='1' after 10 ps;
          tmp <= spacecnt1 after 10 ps;
         muxclk <= (muxclk - 1) after 10 ps;
        end if;

       elsif(space='1')then
        if(tmp > "00000000000000000000000000000000") then
          tmp <= (tmp - 1) after 10 ps ;
          VFEMUXCLK <= '0' after 10 ps;
          mark <='0' after 10 ps;
        else
          mark <= '1' after 10 ps;
          space <='0' after 10 ps;
          tmp <= markcnt1 after 10 ps;
        end if;

      end if;

      end if;

     end if;

   elsif(MLD='0') then
    muxclk <= muxclkdata after 10 ps;
    VFEMUXCLK<='0' after 10 ps;
    tmp <= markcnt1 after 10 ps;
    mark <='1' after 10 ps;
    space <='0' after 10 ps;

   end if;

  end if;
end process first;

END rtl;
