library verilog;
use verilog.vl_types.all;
entity fe_command_decoder is
    generic(
        designator      : integer := 5;
        length_field    : integer := 16;
        reset_length    : integer := 16
    );
    port(
        clk             : in     vl_logic;
        rst             : in     vl_logic;
        command_in      : in     vl_logic;
        soft_rsth       : out    vl_logic;
        fifo_rsth       : out    vl_logic;
        command_out     : out    vl_logic;
        data_valid      : out    vl_logic;
        command_real    : out    vl_logic;
        firmware_id_reg : in     vl_logic_vector(31 downto 0);
        lm82_cntl       : out    vl_logic_vector(16 downto 0);
        lm82_status     : in     vl_logic_vector(15 downto 0);
        lm82_i2c_en     : out    vl_logic;
        addrout         : out    vl_logic_vector(9 downto 0);
        addrout_en      : out    vl_logic;
        datain          : in     vl_logic_vector(31 downto 0);
        datain_rd       : out    vl_logic;
        fifo_data_count : in     vl_logic_vector(31 downto 0);
        dataout         : out    vl_logic_vector(31 downto 0);
        dataout_wr      : out    vl_logic;
        link_reg        : in     vl_logic_vector(31 downto 0);
        vfe_type_reg    : in     vl_logic_vector(31 downto 0);
        trig_int_st     : out    vl_logic;
        trig_data_reg   : in     vl_logic_vector(31 downto 0);
        trig_reg_en     : out    vl_logic
    );
end fe_command_decoder;
