-- hds header_start
--
-- VHDL Architecture CERC_FE_FPGA.addr_decode.rtl
--
-- Created:
--          by - Osman Zorba.UNKNOWN (HEPPC185)
--          at - 17:51:58 09/30/04
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end
LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;

ENTITY addr_decode IS
   PORT( 
      ADDR_SELECT      : IN     std_logic_vector (9 DOWNTO 0);
      CLK              : IN     std_logic;
      RESET            : IN     std_logic;
      enable           : IN     std_logic;
      A0               : OUT    std_logic;
      A1               : OUT    std_logic;
      ADC_EN_1         : OUT    std_logic;
      CONFIG_TRIG      : OUT    std_logic;
      CONFIG_VFEMUXCLK : OUT    std_logic;
      CONFIG_VFE_HOLD  : OUT    std_logic;
      CONFIG_VFE_RESET : OUT    std_logic;
      CONFIG_VFE_SRIN  : OUT    std_logic;
      DAC_EN1          : OUT    std_logic;
      DAC_EN2          : OUT    std_logic;
      FIFO_CONFIG      : OUT    std_logic;
      LD_CALDATA       : OUT    std_logic;
      LD_VFE_ENABLE    : OUT    std_logic;
      fkev_reg_en      : OUT    std_logic
   );

-- Declarations

END addr_decode ;

-- hds interface_end
ARCHITECTURE rtl OF addr_decode IS
BEGIN

	ADDR_DEC:PROCESS (CLK)
	begin

		if(CLK'event and CLK='1') then

	 		if (RESET='1') then
	
		   	LD_CALDATA <='0' after 10 ps;
				CONFIG_TRIG <='0' after 10 ps;
				CONFIG_VFE_HOLD <='0' after 10 ps; 
				CONFIG_VFE_RESET <= '0' after 10 ps;
				CONFIG_VFE_SRIN <= '0' after 10 ps;
				CONFIG_VFEMUXCLK <='0' after 10 ps;
				LD_VFE_ENABLE <='0' after 10 ps;
				ADC_EN_1 <= '0' after 10 ps;
				DAC_EN1 <='0' after 10 ps;
				DAC_EN2 <='0' after 10 ps;
				FIFO_CONFIG <='0' after 10 ps;
				fkev_reg_en <='0' after 10 ps;
	
	
		   elsif(enable='1') then
		
		   	A0 <= ADDR_SELECT(0);
		   	A1 <= ADDR_SELECT(1);
		   	
		 
		      if( ADDR_SELECT >= "0000000000" and ADDR_SELECT <= "0000000011") then
		
					LD_CALDATA <='1' after 10 ps;
					CONFIG_TRIG <='0' after 10 ps;
					CONFIG_VFE_HOLD <='0' after 10 ps; 
					CONFIG_VFE_RESET <= '0' after 10 ps;
					CONFIG_VFE_SRIN <= '0' after 10 ps;
					CONFIG_VFEMUXCLK <='0' after 10 ps;
					LD_VFE_ENABLE <='0' after 10 ps;
					ADC_EN_1 <= '0' after 10 ps;
					DAC_EN1 <='0' after 10 ps;
					DAC_EN2 <='0' after 10 ps;
					FIFO_CONFIG <='0' after 10 ps;
					fkev_reg_en <='0' after 10 ps;
		
		
		      elsif( ADDR_SELECT >= "0000000100" and ADDR_SELECT <= "0000000111" ) then
		
					LD_CALDATA <='0' after 10 ps;
					CONFIG_TRIG <='1' after 10 ps;
					CONFIG_VFE_HOLD <='0' after 10 ps; 
					CONFIG_VFE_RESET <= '0' after 10 ps;
					CONFIG_VFE_SRIN <= '0' after 10 ps;
					CONFIG_VFEMUXCLK <='0' after 10 ps;
					LD_VFE_ENABLE <='0' after 10 ps;
					ADC_EN_1 <= '0' after 10 ps;
					DAC_EN1 <='0' after 10 ps;
					DAC_EN2 <='0' after 10 ps;
					FIFO_CONFIG <='0' after 10 ps;                     
					fkev_reg_en <='0' after 10 ps;
		
		
		      elsif( ADDR_SELECT >= "0000001000" and ADDR_SELECT <= "0000001011" ) then 
		
					LD_CALDATA <='0' after 10 ps;
					CONFIG_TRIG <='0' after 10 ps;
					CONFIG_VFE_HOLD <='1' after 10 ps; 
					CONFIG_VFE_RESET <= '0' after 10 ps;
					CONFIG_VFE_SRIN <= '0' after 10 ps;
					CONFIG_VFEMUXCLK <='0' after 10 ps;
					LD_VFE_ENABLE <='0' after 10 ps;
					ADC_EN_1 <= '0' after 10 ps;
					DAC_EN1 <='0' after 10 ps;
					DAC_EN2 <='0' after 10 ps;
					FIFO_CONFIG <='0' after 10 ps;
					fkev_reg_en <='0' after 10 ps;
		
		
		      elsif( ADDR_SELECT >= "0000001100" and ADDR_SELECT <= "0000001111" ) then 
		
					LD_CALDATA <='0' after 10 ps;
					CONFIG_TRIG <='0' after 10 ps;
					CONFIG_VFE_HOLD <='0' after 10 ps; 
					CONFIG_VFE_RESET <= '1' after 10 ps;
					CONFIG_VFE_SRIN <= '0' after 10 ps;
					CONFIG_VFEMUXCLK <='0' after 10 ps;
					LD_VFE_ENABLE <='0' after 10 ps;                                 
					ADC_EN_1 <= '0' after 10 ps;
					DAC_EN1 <='0' after 10 ps;
					DAC_EN2 <='0' after 10 ps;
					FIFO_CONFIG <='0' after 10 ps;
					fkev_reg_en <='0' after 10 ps;
		
		
		      elsif( ADDR_SELECT >= "0000010000" and ADDR_SELECT <= "0000010011" ) then
		
					LD_CALDATA <='0' after 10 ps;
					CONFIG_TRIG <='0' after 10 ps;
					CONFIG_VFE_HOLD <='0' after 10 ps; 
					CONFIG_VFE_RESET <= '0' after 10 ps;
					CONFIG_VFE_SRIN <= '1' after 10 ps;
					CONFIG_VFEMUXCLK <='0' after 10 ps;
					LD_VFE_ENABLE <='0' after 10 ps;   
					ADC_EN_1 <= '0' after 10 ps;
					DAC_EN1 <='0' after 10 ps;
					DAC_EN2 <='0' after 10 ps;
					FIFO_CONFIG <='0' after 10 ps;
					fkev_reg_en <='0' after 10 ps;
		
		                              
		     elsif( ADDR_SELECT >= "0000010100" and ADDR_SELECT <= "0000010111" ) then
		
					LD_CALDATA <='0' after 10 ps;
					CONFIG_TRIG <='0' after 10 ps;
					CONFIG_VFE_HOLD <='0' after 10 ps; 
					CONFIG_VFE_RESET <= '0' after 10 ps;
					CONFIG_VFE_SRIN <= '0' after 10 ps;
					CONFIG_VFEMUXCLK <='1' after 10 ps;
					LD_VFE_ENABLE <='0' after 10 ps;                                 
					ADC_EN_1 <= '0' after 10 ps;
					DAC_EN1 <='0' after 10 ps;
					DAC_EN2 <='0' after 10 ps;
					FIFO_CONFIG <='0' after 10 ps;
					fkev_reg_en <='0' after 10 ps;
		
		
		      elsif( ADDR_SELECT = "0000011000") then -- and ADDR_SELECT <= "00011011" ) then
		
					LD_CALDATA <='0' after 10 ps;
					CONFIG_TRIG <='0' after 10 ps;
					CONFIG_VFE_HOLD <='0' after 10 ps; 
					CONFIG_VFE_RESET <= '0' after 10 ps;
					CONFIG_VFE_SRIN <= '0' after 10 ps;
					CONFIG_VFEMUXCLK <='0' after 10 ps;
					LD_VFE_ENABLE <='1' after 10 ps;                                 
					ADC_EN_1 <= '0' after 10 ps;
					DAC_EN1 <='0' after 10 ps;
					DAC_EN2 <='0' after 10 ps;
					FIFO_CONFIG <='0' after 10 ps;
					fkev_reg_en <='0' after 10 ps;
		
		
		      elsif( ADDR_SELECT >= "0000011100" and ADDR_SELECT <= "0000011111" ) then
		
					LD_CALDATA <='0' after 10 ps;
					CONFIG_TRIG <='0' after 10 ps;
					CONFIG_VFE_HOLD <='0' after 10 ps; 
					CONFIG_VFE_RESET <= '0' after 10 ps;
					CONFIG_VFE_SRIN <= '0' after 10 ps;
					CONFIG_VFEMUXCLK <='0' after 10 ps;
					LD_VFE_ENABLE <='0' after 10 ps;                                 
					ADC_EN_1 <= '1' after 10 ps;
					DAC_EN1 <='0' after 10 ps;
					DAC_EN2 <='0' after 10 ps;
					FIFO_CONFIG <='0' after 10 ps;
					fkev_reg_en <='0' after 10 ps;
		
		
		      elsif( ADDR_SELECT = "0000100000" ) then
		
					LD_CALDATA <='0' after 10 ps;
					CONFIG_TRIG <='0' after 10 ps;
					CONFIG_VFE_HOLD <='0' after 10 ps; 
					CONFIG_VFE_RESET <= '0' after 10 ps;
					CONFIG_VFE_SRIN <= '0' after 10 ps;
					CONFIG_VFEMUXCLK <='0' after 10 ps;
					LD_VFE_ENABLE <='0' after 10 ps;                                 
					ADC_EN_1 <= '0' after 10 ps;
					DAC_EN1 <='1' after 10 ps;
					DAC_EN2 <='0' after 10 ps;
					FIFO_CONFIG <='0' after 10 ps;
					fkev_reg_en <='0' after 10 ps;
						
		
		      elsif( ADDR_SELECT = "0000100001" ) then
		
					LD_CALDATA <='0' after 10 ps;
					CONFIG_TRIG <='0' after 10 ps;
					CONFIG_VFE_HOLD <='0' after 10 ps; 
					CONFIG_VFE_RESET <= '0' after 10 ps;
					CONFIG_VFE_SRIN <= '0' after 10 ps;
					CONFIG_VFEMUXCLK <='0' after 10 ps;
					LD_VFE_ENABLE <='0' after 10 ps;                                 
					ADC_EN_1 <= '0' after 10 ps;
					DAC_EN1 <='0' after 10 ps;
					DAC_EN2 <='1' after 10 ps;
					FIFO_CONFIG <='0' after 10 ps;
					fkev_reg_en <='0' after 10 ps;
		
		
		
		      elsif( ADDR_SELECT = "0111111111") then
		
					LD_CALDATA <='0' after 10 ps;
					CONFIG_TRIG <='0' after 10 ps;
					CONFIG_VFE_HOLD <='0' after 10 ps; 
					CONFIG_VFE_RESET <= '0' after 10 ps;
					CONFIG_VFE_SRIN <= '0' after 10 ps;
					CONFIG_VFEMUXCLK <='0' after 10 ps;
					LD_VFE_ENABLE <='0' after 10 ps;                                 
					ADC_EN_1 <= '0' after 10 ps;
					DAC_EN1 <='0' after 10 ps;
					DAC_EN2 <='0' after 10 ps;
					FIFO_CONFIG <='0' after 10 ps;
					fkev_reg_en <='1' after 10 ps;
		
		
		      elsif( ADDR_SELECT = "0000100011") then
		
					LD_CALDATA <='0' after 10 ps;
					CONFIG_TRIG <='0' after 10 ps;
					CONFIG_VFE_HOLD <='0' after 10 ps; 
					CONFIG_VFE_RESET <= '0' after 10 ps;
					CONFIG_VFE_SRIN <= '0' after 10 ps;
					CONFIG_VFEMUXCLK <='0' after 10 ps;
					LD_VFE_ENABLE <='0' after 10 ps;                                 
					ADC_EN_1 <= '0' after 10 ps;
					DAC_EN1 <='0' after 10 ps;
					DAC_EN2 <='0' after 10 ps;
					--		   FIFO_CONFIG <='1' after 10 ps;
					fkev_reg_en <='0' after 10 ps;
	
	      
			   else
					LD_CALDATA <='0' after 10 ps;
					CONFIG_TRIG <='0' after 10 ps;
					CONFIG_VFE_HOLD <='0' after 10 ps; 
					CONFIG_VFE_RESET <= '0' after 10 ps;
					CONFIG_VFE_SRIN <= '0' after 10 ps;
					CONFIG_VFEMUXCLK <='0' after 10 ps;
					LD_VFE_ENABLE <='0' after 10 ps;                                 
					ADC_EN_1 <= '0' after 10 ps;
					DAC_EN1 <='0' after 10 ps;
					DAC_EN2 <='0' after 10 ps;
					FIFO_CONFIG <='0' after 10 ps;
					fkev_reg_en <='0' after 10 ps;
	
				end if;
			end if;
		end if;
	end process ADDR_DEC;

END rtl;
