-- hds header_start
--
-- VHDL Architecture CERC_FE_FPGA.comm_hs.rtl
--
-- Created:
--          by - Osman Zorba.UNKNOWN (HEPPC185)
--          at - 15:56:21 10/14/04
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end
LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;
USE ieee.std_logic_unsigned.ALL;

ENTITY comm_hs IS
   PORT( 
      clk80            : IN     STD_ULOGIC;
      frame_sync_out   : IN     STD_ULOGIC;
      readout_sync_in  : IN     std_logic;
      readout_sync_out : IN     STD_ULOGIC;
      rst              : IN     std_logic;
      transfer_en      : OUT    std_logic
   );

-- Declarations

END comm_hs ;

-- hds interface_end
ARCHITECTURE rtl OF comm_hs IS
signal frmq, rdiq, rdoq, fram1, read1 : std_logic;

BEGIN


process(clk80)
begin
	if(clk80'event and clk80='1') then
	  if(rst='1') then
	     transfer_en <='0';
		 frmq <= '0';
		 rdiq <= '0';
		 rdoq <= '0';
		 fram1 <= '0';
		 read1 <= '0';

	  else
	     frmq <= frame_sync_out;
		 rdiq <= readout_sync_in;
		 rdoq <= readout_sync_out;

        if(frmq='0' and frame_sync_out='1') then
		  fram1 <= '1';
		end if;

		if(rdoq='0' and readout_sync_out='1') then
 	       read1 <= '1';
  	    end if;

		if(fram1='1' and read1='1') then
		   transfer_en <='1';
		else 
		   transfer_en <='0';
		end if;

		if(rdiq='1' and  readout_sync_in='0') then
		   fram1 <= '0';
		   read1 <= '0';
  	    end if;
	  end if;
    end if;

end process;

END rtl;
