-- hds header_start
--
-- VHDL Architecture ADC_VFE_Module.event_store1.rtl1
--
-- Created:
--          by - zorba.UNKNOWN (TE2BELMOPAN)
--          at - 13:48:04 02/10/04
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end
LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;
USE ieee.std_logic_unsigned.ALL;


ENTITY event_store1 IS
   PORT( 
      CLK40           : IN     std_logic;
      DATA_VALID      : IN     std_logic;
      RESET           : IN     std_logic;
      MLD             : IN     std_logic;
      CONFIG_SELECT   : IN     std_logic;
      SET_DATA        : IN     std_logic_vector (31 DOWNTO 0);
      event_wr        : OUT    std_logic;
      ADC_DATA_SELECT : OUT    std_logic_vector (7 DOWNTO 0)
   );

-- Declarations

END event_store1 ;

-- hds interface_end
ARCHITECTURE rtl1 OF event_store1 IS
signal a, b, rising, falling,eventwr_int : std_logic;
signal counter : std_logic_vector(7 downto 0);
signal fifocounter : std_logic_vector(7 downto 0);

BEGIN
process(CLK40)
begin
  if(CLK40'event and CLK40='0') then

     if(RESET='1') then
       ADC_DATA_SELECT <= (others=> '0');
	   counter <= "00000000";
	  -- fifocounter <= "00000000";
	   eventwr_int <= '0';
	   fifocounter <= "00001001";
	   a <= '0';
	   b <='0';
	   rising <= '0';
	   falling <= '0';

--	 elsif(CONFIG_SELECT='1') then
--	    fifocounter <= SET_DATA(7 downto 0);

	 else
       a <= b;
	   b <= DATA_VALID;

	  if(MLD='1') then
       if(a='1' and b='0') then  -- data not valid
	     falling <= '1';
	     rising <= '0';
         counter <= "00000000";
	     eventwr_int <= '0';

       elsif(a='0' and b='1') then -- data valid
	     falling <= '0';
	     rising <= '1';
	   end if;
	 
	   if(rising='1') then   -- if data valid
        if(counter < fifocounter) then   -- enable fifo in counter
          counter <= counter + 1;
	      eventwr_int <= '1';
        else
          counter <= "00000000";
          eventwr_int <= '0';
	      rising <= '0';
        end if;	   
	   end if;

    end if;
  end if;

  event_wr <= eventwr_int;

  end if;

  ADC_DATA_SELECT <= counter;

end process;
END rtl1;
