-- hds header_start
--
-- VHDL Architecture CERC_FE_FPGA.readoutsync_dly.rtl
--
-- Created:
--          by - Osman Zorba.UNKNOWN (HEPPC185)
--          at - 15:35:25 10/13/04
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end
LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;
USE ieee.numeric_std.all;
USE ieee.std_logic_textio.all;
USE ieee.std_logic_unsigned.ALL;

ENTITY readoutsync_dly IS
   PORT( 
      addr            : IN     std_logic_vector (9 DOWNTO 0);
      clk40           : IN     std_logic;
      clk40d          : IN     std_logic;
      db_in           : IN     std_logic_vector (31 DOWNTO 0);
      db_rd           : IN     std_logic;
      db_wr           : IN     std_logic;
      readout_sync_in : IN     std_logic;
      rst             : IN     std_logic;
      db_out          : OUT    std_logic_vector (31 DOWNTO 0);
      readoutsyncdly  : OUT    std_logic
   );

-- Declarations

END readoutsync_dly ;

-- hds interface_end
ARCHITECTURE rtl OF readoutsync_dly IS
signal counter, reg, db_out_int : std_logic_vector (31 downto 0);
signal trigqm, countst, trigdly_int : std_logic;

BEGIN

first:process (clk40d)
begin
 if(CLK40d'event and CLK40d='1') then
  if (rst='1') then
    reg <= "00000000000000000000000000000001";
    counter <= "00000000000000000000000000000001";
	db_out <= (others => 'Z');

  elsif (addr = "00000000000000000000000000100011" and db_wr='1') then
	   reg<= db_in;
	   counter <= db_in;
  elsif(addr = "00000000000000000000000000100011" and db_rd='1') then
	   db_out <= reg;
  else
	   db_out <= (others => 'Z');
  end if;

 end if;

 end process first;

second:process(clk40)
  if(CLK40'event and CLK40='1') then
   if (rst='1') then
    trigdly_int <= '0';
	trigqm <='0';
	countst<='0';
	readoutsyncdly <= '0';

   else
    trigqm<= readout_sync_in;

	if (trigqm='1' and readout_sync_in='0') then
      countst <= '1';
	  trigdly_int <='0';
	elsif(counter > "00000000000000000000000000000000" and countst='1') then
	    counter <= counter - 1;
	    if(counter > "0000000000000000000000000000001") then
	      trigdly_int <= '1';
		end if;
	else
	    counter <= reg ;
		trigdly_int <= '0';
		countst <='0';
    end if;
  end if;
  end if;
 end if;

end process second;

  readoutsyncdly <= trigdly_int;

END rtl;
